# 1 "src/arch/riscv/arch_timer.c"
# 1 "<built-in>" 1
# 1 "<built-in>" 3
# 381 "<built-in>" 3
# 1 "<command line>" 1
# 1 "<built-in>" 2
# 1 "./src/include/kconfig.h" 1



# 1 "/cb-build/coreboot_scanbuild.0/EMULATION_SPIKE_RISCV/config.h" 1
# 5 "./src/include/kconfig.h" 2
# 2 "<built-in>" 2
# 1 "./src/include/rules.h" 1
# 3 "<built-in>" 2
# 1 "./src/commonlib/bsd/include/commonlib/bsd/compiler.h" 1
# 4 "<built-in>" 2
# 1 "src/arch/riscv/arch_timer.c" 2


# 1 "src/include/device/mmio.h" 1





# 1 "src/arch/riscv/include/arch/mmio.h" 1





# 1 "src/include/endian.h" 1





# 1 "src/arch/riscv/include/arch/byteorder.h" 1
# 7 "src/include/endian.h" 2
# 1 "src/include/stdint.h" 1






typedef signed char int8_t;
typedef unsigned char uint8_t;

typedef signed short int16_t;
typedef unsigned short uint16_t;

typedef signed int int32_t;
typedef unsigned int uint32_t;

typedef signed long long int64_t;
typedef unsigned long long uint64_t;


typedef signed long intptr_t;
typedef unsigned long uintptr_t;


_Static_assert(sizeof(int8_t) == 1, "Size of int8_t is incorrect");
_Static_assert(sizeof(uint8_t) == 1, "Size of uint8_t is incorrect");

_Static_assert(sizeof(int16_t) == 2, "Size of int16_t is incorrect");
_Static_assert(sizeof(uint16_t) == 2, "Size of uint16_t is incorrect");

_Static_assert(sizeof(int32_t) == 4, "Size of int32_t is incorrect");
_Static_assert(sizeof(uint32_t) == 4, "Size of uint32_t is incorrect");

_Static_assert(sizeof(int64_t) == 8, "Size of int64_t is incorrect");
_Static_assert(sizeof(uint64_t) == 8, "Size of uint64_t is incorrect");

_Static_assert(sizeof(intptr_t) == sizeof(void *), "Size of intptr_t is incorrect");
_Static_assert(sizeof(uintptr_t) == sizeof(void *), "Size of uintptr_t is incorrect");


typedef int64_t intmax_t;
typedef uint64_t uintmax_t;


typedef int8_t s8;
typedef uint8_t u8;

typedef int16_t s16;
typedef uint16_t u16;

typedef int32_t s32;
typedef uint32_t u32;

typedef int64_t s64;
typedef uint64_t u64;
# 8 "src/include/endian.h" 2
# 1 "src/include/swab.h" 1
# 9 "src/include/endian.h" 2
# 76 "src/include/endian.h"
static inline uint16_t be16dec(const void *p) { return ((uint16_t)__builtin_bswap16(*(uint16_t *)p)); }
static inline uint32_t be32dec(const void *p) { return ((uint32_t)__builtin_bswap32(*(uint32_t *)p)); }
static inline uint64_t be64dec(const void *p) { return ((uint64_t)__builtin_bswap64(*(uint64_t *)p)); }
static inline uint16_t le16dec(const void *p) { return ((uint16_t)(*(uint16_t *)p)); }
static inline uint32_t le32dec(const void *p) { return ((uint32_t)(*(uint32_t *)p)); }
static inline uint64_t le64dec(const void *p) { return ((uint64_t)(*(uint64_t *)p)); }







static inline void be16enc(void *p, uint16_t u) { *(uint16_t *)p = ((uint16_t)__builtin_bswap16(u)); }
static inline void be32enc(void *p, uint32_t u) { *(uint32_t *)p = ((uint32_t)__builtin_bswap32(u)); }
static inline void be64enc(void *p, uint64_t u) { *(uint64_t *)p = ((uint64_t)__builtin_bswap64(u)); }
static inline void le16enc(void *p, uint16_t u) { *(uint16_t *)p = ((uint16_t)(u)); }
static inline void le32enc(void *p, uint32_t u) { *(uint32_t *)p = ((uint32_t)(u)); }
static inline void le64enc(void *p, uint64_t u) { *(uint64_t *)p = ((uint64_t)(u)); }





static inline uint16_t htobe16(uint16_t host_16bits)
{
 return ((uint16_t)__builtin_bswap16(host_16bits));
}

static inline uint16_t htole16(uint16_t host_16bits)
{
 return ((uint16_t)(host_16bits));
}

static inline uint16_t be16toh(uint16_t big_endian_16bits)
{
 return ((uint16_t)__builtin_bswap16(big_endian_16bits));
}

static inline uint16_t le16toh(uint16_t little_endian_16bits)
{
 return ((uint16_t)(little_endian_16bits));
}

static inline uint32_t htobe32(uint32_t host_32bits)
{
 return ((uint32_t)__builtin_bswap32(host_32bits));
}

static inline uint32_t htole32(uint32_t host_32bits)
{
 return ((uint32_t)(host_32bits));
}

static inline uint32_t be32toh(uint32_t big_endian_32bits)
{
 return ((uint32_t)__builtin_bswap32(big_endian_32bits));
}

static inline uint32_t le32toh(uint32_t little_endian_32bits)
{
 return ((uint32_t)(little_endian_32bits));
}

static inline uint64_t htobe64(uint64_t host_64bits)
{
 return ((uint64_t)__builtin_bswap64(host_64bits));
}

static inline uint64_t htole64(uint64_t host_64bits)
{
 return ((uint64_t)(host_64bits));
}

static inline uint64_t be64toh(uint64_t big_endian_64bits)
{
 return ((uint64_t)__builtin_bswap64(big_endian_64bits));
}

static inline uint64_t le64toh(uint64_t little_endian_64bits)
{
 return ((uint64_t)(little_endian_64bits));
}
# 7 "src/arch/riscv/include/arch/mmio.h" 2


static inline __attribute__((__always_inline__)) uint8_t read8(const volatile void *addr)
{
 return *((volatile uint8_t *)(addr));
}

static inline __attribute__((__always_inline__)) uint16_t read16(const volatile void *addr)
{
 return *((volatile uint16_t *)(addr));
}

static inline __attribute__((__always_inline__)) uint32_t read32(const volatile void *addr)
{
 return *((volatile uint32_t *)(addr));
}

static inline __attribute__((__always_inline__)) uint64_t read64(const volatile void *addr)
{
 return *((volatile uint64_t *)(addr));
}

static inline __attribute__((__always_inline__)) void write8(volatile void *addr, uint8_t value)
{
 *((volatile uint8_t *)(addr)) = value;
}

static inline __attribute__((__always_inline__)) void write16(volatile void *addr, uint16_t value)
{
 *((volatile uint16_t *)(addr)) = value;
}

static inline __attribute__((__always_inline__)) void write32(volatile void *addr, uint32_t value)
{
 *((volatile uint32_t *)(addr)) = value;
}

static inline __attribute__((__always_inline__)) void write64(volatile void *addr, uint64_t value)
{
 *((volatile uint64_t *)(addr)) = value;
}
# 7 "src/include/device/mmio.h" 2
# 1 "src/commonlib/include/commonlib/helpers.h" 1
# 10 "src/commonlib/include/commonlib/helpers.h"
# 1 "src/commonlib/bsd/include/commonlib/bsd/helpers.h" 1







# 1 "src/include/stddef.h" 1





# 1 "src/commonlib/include/commonlib/helpers.h" 1
# 7 "src/include/stddef.h" 2

typedef long int ptrdiff_t;
typedef long unsigned int size_t;






typedef long signed int ssize_t;


typedef int wchar_t;
typedef unsigned int wint_t;
# 42 "src/include/stddef.h"
extern char zeroptr[];
# 9 "src/commonlib/bsd/include/commonlib/bsd/helpers.h" 2
# 11 "src/commonlib/include/commonlib/helpers.h" 2
# 8 "src/include/device/mmio.h" 2

# 1 "src/include/types.h" 1







# 1 "src/commonlib/bsd/include/commonlib/bsd/cb_err.h" 1
# 15 "src/commonlib/bsd/include/commonlib/bsd/cb_err.h"
enum cb_err {
 CB_SUCCESS = 0,
 CB_ERR = -1,
 CB_ERR_ARG = -2,
 CB_ERR_NOT_IMPLEMENTED = -3,


 CB_CMOS_OTABLE_DISABLED = -100,
 CB_CMOS_LAYOUT_NOT_FOUND = -101,
 CB_CMOS_OPTION_NOT_FOUND = -102,
 CB_CMOS_ACCESS_ERROR = -103,
 CB_CMOS_CHECKSUM_INVALID = -104,


 CB_KBD_CONTROLLER_FAILURE = -200,
 CB_KBD_INTERFACE_FAILURE = -201,


 CB_I2C_NO_DEVICE = -300,
 CB_I2C_BUSY = -301,
 CB_I2C_PROTOCOL_ERROR = -302,

 CB_I2C_TIMEOUT = -303,


 CB_CBFS_IO = -400,
 CB_CBFS_NOT_FOUND = -401,
 CB_CBFS_HASH_MISMATCH = -402,
 CB_CBFS_CACHE_FULL = -403,


 CB_EFI_FVH_INVALID = -500,
 CB_EFI_CHECKSUM_INVALID = -501,
 CB_EFI_VS_NOT_FORMATTED_INVALID = -502,
 CB_EFI_VS_CORRUPTED_INVALID = -503,
 CB_EFI_ACCESS_ERROR = -504,
 CB_EFI_STORE_FULL = -505,
 CB_EFI_OPTION_NOT_FOUND = -506,
 CB_EFI_BUFFER_TOO_SMALL = -507,
};
# 9 "src/include/types.h" 2
# 1 "src/include/limits.h" 1
# 10 "src/include/types.h" 2
# 1 "src/include/stdbool.h" 1





typedef _Bool bool;
# 11 "src/include/types.h" 2
# 10 "src/include/device/mmio.h" 2
# 50 "src/include/device/mmio.h"
void buffer_from_fifo32(void *buffer, size_t size, void *fifo,
   int fifo_stride, int fifo_width);
# 60 "src/include/device/mmio.h"
void buffer_to_fifo32_prefix(const void *buffer, u32 prefix, int prefsz, size_t size,
        void *fifo, int fifo_stride, int fifo_width);







static inline void buffer_to_fifo32(const void *buffer, size_t size, void *fifo,
        int fifo_stride, int fifo_width)
{
 buffer_to_fifo32_prefix(buffer, 0, 0, size, fifo,
    fifo_stride, fifo_width);
}
# 225 "src/include/device/mmio.h"
static inline __attribute__((__always_inline__)) uint8_t read8p(const uintptr_t addr)
{
 return read8((void *)addr);
}

static inline __attribute__((__always_inline__)) uint16_t read16p(const uintptr_t addr)
{
 return read16((void *)addr);
}

static inline __attribute__((__always_inline__)) uint32_t read32p(const uintptr_t addr)
{
 return read32((void *)addr);
}

static inline __attribute__((__always_inline__)) uint64_t read64p(const uintptr_t addr)
{
 return read64((void *)addr);
}

static inline __attribute__((__always_inline__)) void write8p(const uintptr_t addr, const uint8_t value)
{
 write8((void *)addr, value);
}

static inline __attribute__((__always_inline__)) void write16p(const uintptr_t addr, const uint16_t value)
{
 write16((void *)addr, value);
}

static inline __attribute__((__always_inline__)) void write32p(const uintptr_t addr, const uint32_t value)
{
 write32((void *)addr, value);
}

static inline __attribute__((__always_inline__)) void write64p(const uintptr_t addr, const uint64_t value)
{
 write64((void *)addr, value);
}
# 4 "src/arch/riscv/arch_timer.c" 2
# 1 "src/arch/riscv/include/arch/encoding.h" 1
# 5 "src/arch/riscv/arch_timer.c" 2
# 1 "src/include/console/console.h" 1





# 1 "src/commonlib/include/commonlib/console/post_codes.h" 1
# 7 "src/include/console/console.h" 2
# 1 "src/include/console/vtxprintf.h" 1





# 1 "src/include/stdarg.h" 1
# 16 "src/include/stdarg.h"
typedef __builtin_va_list va_list;

int vsnprintf(char *buf, size_t size, const char *fmt, va_list args);
# 7 "src/include/console/vtxprintf.h" 2

int vtxprintf(void (*tx_byte)(unsigned char byte, void *data),
 const char *fmt, va_list args, void *data);
# 8 "src/include/console/console.h" 2



# 1 "src/commonlib/include/commonlib/loglevel.h" 1
# 168 "src/commonlib/include/commonlib/loglevel.h"
static const char bios_log_prefix[8 + 1][5] = {

 [0] = "EMERG",
 [1] = "ALERT",
 [2] = "CRIT ",
 [3] = "ERROR",
 [4] = "WARN ",
 [5] = "NOTE ",
 [6] = "INFO ",
 [7] = "DEBUG",
 [8] = "SPEW ",
};
# 192 "src/commonlib/include/commonlib/loglevel.h"
static const char bios_log_escape[8 + 1][8] = {
 [0] = "1;4;5;7",
 [1] = "1;4;7",
 [2] = "1;7",
 [3] = "7",
 [4] = "1;4",
 [5] = "1",
 [6] = "0",
 [7] = "0",
 [8] = "0",
};
# 12 "src/include/console/console.h" 2




void post_code(u8 value);
void mainboard_post(u8 value);
void arch_post_code(u8 value);
void soc_post_code(uint8_t value);

void __attribute__((__noreturn__)) __attribute__((format(printf, 1, 2))) die(const char *fmt, ...);







void die_notify(void);
# 38 "src/include/console/console.h"
static inline int get_console_loglevel(void)
{
 return 7;
}
# 51 "src/include/console/console.h"
int get_log_level(void);
void console_init(void);
int console_log_level(int msg_level);

int printk(int msg_level, const char *fmt, ...) __attribute__((format(printf, 2, 3)));
int vprintk(int msg_level, const char *fmt, va_list args);

void do_putchar(unsigned char byte);



long console_time_get_and_reset(void);
void console_time_report(void);







enum { CONSOLE_LOG_NONE = 0, CONSOLE_LOG_FAST, CONSOLE_LOG_ALL };
# 6 "src/arch/riscv/arch_timer.c" 2
# 1 "src/include/timer.h" 1
# 19 "src/include/timer.h"
struct mono_time {
 uint64_t microseconds;
};





struct timeout_callback {
 void *priv;
 void (*callback)(struct timeout_callback *tocb);

 struct mono_time expiration;
};
# 43 "src/include/timer.h"
void timer_monotonic_get(struct mono_time *mt);


int timers_run(void);



int timer_sched_callback(struct timeout_callback *tocb, uint64_t us);


static inline void mono_time_set_usecs(struct mono_time *mt, uint64_t us)
{
 mt->microseconds = us;
}


static inline void mono_time_set_msecs(struct mono_time *mt, uint64_t ms)
{
 mt->microseconds = ms * (1000000 / 1000);
}


static inline void mono_time_add_usecs(struct mono_time *mt, int64_t us)
{
 mt->microseconds += us;
}


static inline void mono_time_add_msecs(struct mono_time *mt, int64_t ms)
{
 mono_time_add_usecs(mt, ms * (1000000 / 1000));
}



static inline int mono_time_cmp(const struct mono_time *t1,
    const struct mono_time *t2)
{
 if (t1->microseconds == t2->microseconds)
  return 0;

 if (t1->microseconds < t2->microseconds)
  return -1;

 return 1;
}


static inline int mono_time_after(const struct mono_time *t1,
      const struct mono_time *t2)
{
 return mono_time_cmp(t1, t2) > 0;
}


static inline int mono_time_before(const struct mono_time *t1,
       const struct mono_time *t2)
{
 return mono_time_cmp(t1, t2) < 0;
}


static inline int64_t mono_time_diff_microseconds(const struct mono_time *t1,
        const struct mono_time *t2)
{
 return t2->microseconds - t1->microseconds;
}

struct stopwatch {
 struct mono_time start;
 struct mono_time current;
 struct mono_time expires;
};

static inline void stopwatch_init(struct stopwatch *sw)
{
 if (1)
  timer_monotonic_get(&sw->start);
 else
  sw->start.microseconds = 0;

 sw->current = sw->expires = sw->start;
}

static inline void stopwatch_init_usecs_expire(struct stopwatch *sw, uint64_t us)
{
 stopwatch_init(sw);
 mono_time_add_usecs(&sw->expires, us);
}

static inline void stopwatch_init_msecs_expire(struct stopwatch *sw, uint64_t ms)
{
 stopwatch_init_usecs_expire(sw, (1000000 / 1000) * ms);
}




static inline void stopwatch_tick(struct stopwatch *sw)
{
 if (1)
  timer_monotonic_get(&sw->current);
 else
  sw->current.microseconds = 0;
}




static inline int stopwatch_expired(struct stopwatch *sw)
{
 stopwatch_tick(sw);
 return !mono_time_before(&sw->current, &sw->expires);
}




static inline void stopwatch_wait_until_expired(struct stopwatch *sw)
{
 while (!stopwatch_expired(sw))
  ;
}




static inline int64_t stopwatch_duration_usecs(struct stopwatch *sw)
{




 if (!mono_time_cmp(&sw->start, &sw->current))
  stopwatch_tick(sw);

 return mono_time_diff_microseconds(&sw->start, &sw->current);
}

static inline int64_t stopwatch_duration_msecs(struct stopwatch *sw)
{
 return stopwatch_duration_usecs(sw) / (1000000 / 1000);
}
# 7 "src/arch/riscv/arch_timer.c" 2
# 1 "src/arch/riscv/include/mcall.h" 1
# 21 "src/arch/riscv/include/mcall.h"
# 1 "src/arch/riscv/include/arch/encoding.h" 1
# 22 "src/arch/riscv/include/mcall.h" 2
# 1 "src/arch/riscv/include/arch/smp/atomic.h" 1





# 1 "src/arch/riscv/include/arch/encoding.h" 1
# 7 "src/arch/riscv/include/arch/smp/atomic.h" 2

typedef struct { volatile int counter; } atomic_t;
# 24 "src/arch/riscv/include/arch/smp/atomic.h"
static inline int atomic_add(atomic_t *v, int inc)
{
 long flags = ({ unsigned long __tmp; asm volatile ("csrrc %0, " "mstatus" ", %1" : "=r"(__tmp) : "rK"(0x00000008)); __tmp; });
 int res = v->counter;
 v->counter += inc;
 ({ unsigned long __tmp; asm volatile ("csrrs %0, " "mstatus" ", %1" : "=r"(__tmp) : "rK"((flags) & 0x00000008)); __tmp; });
 return res;
}

static inline int atomic_swap(atomic_t *v, int swp)
{
 long flags = ({ unsigned long __tmp; asm volatile ("csrrc %0, " "mstatus" ", %1" : "=r"(__tmp) : "rK"(0x00000008)); __tmp; });
 int res = v->counter;
 v->counter = swp;
 ({ unsigned long __tmp; asm volatile ("csrrs %0, " "mstatus" ", %1" : "=r"(__tmp) : "rK"((flags) & 0x00000008)); __tmp; });
 return res;
}

static inline int atomic_cas(atomic_t *v, int cmp, int swp)
{
 long flags = ({ unsigned long __tmp; asm volatile ("csrrc %0, " "mstatus" ", %1" : "=r"(__tmp) : "rK"(0x00000008)); __tmp; });
 int res = v->counter;
 v->counter = (res == cmp ? swp : res);
 ({ unsigned long __tmp; asm volatile ("csrrs %0, " "mstatus" ", %1" : "=r"(__tmp) : "rK"((flags) & 0x00000008)); __tmp; });
 return res;
}

static inline int atomic_inc(atomic_t *v)
{
 return atomic_add(v, 1);
}

static inline int atomic_dec(atomic_t *v)
{
 return atomic_add(v, -1);
}
# 23 "src/arch/riscv/include/mcall.h" 2


struct sbi_device_message {
 unsigned long dev;
 unsigned long cmd;
 unsigned long data;
 unsigned long sbi_private_data;
};

struct blocker {
 void *arg;
 void (*fn)(void *arg);
 atomic_t sync_a;
 atomic_t sync_b;
};

struct hls {
 struct sbi_device_message *device_request_queue_head;
 unsigned long device_request_queue_size;
 struct sbi_device_message *device_response_queue_head;
 struct sbi_device_message *device_response_queue_tail;

 int hart_id;
 int ipi_pending;
 uint64_t *timecmp;
 uint64_t *time;
 void *fdt;
 struct blocker entry;
};

_Static_assert(
 sizeof(struct hls) == 88,
 "HLS_SIZE must equal to sizeof(struct hls)");

register uintptr_t current_stack_pointer asm("sp");
# 69 "src/arch/riscv/include/mcall.h"
void hls_init(uint32_t hart_id, void *fdt);


void mtime_init(void);
# 81 "src/arch/riscv/include/mcall.h"
void set_msip(int hartid, int val);
# 8 "src/arch/riscv/arch_timer.c" 2

void timer_monotonic_get(struct mono_time *mt)
{
 if (((struct hls *)(({ (void *)((current_stack_pointer + (1 << 12)) & -(1 << 12)); }) - 88))->time == ((void *)0))
  die("time not set in HLS");
 mono_time_set_usecs(mt, (long)read64((void *)(((struct hls *)(({ (void *)((current_stack_pointer + (1 << 12)) & -(1 << 12)); }) - 88))->time)));
}
